# SwaggerClient::RecipientsApi

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_recipients**](RecipientsApi.md#get_recipients) | **GET** /recipients | /recipients

# **get_recipients**
> Recipients get_recipients(opts)

/recipients

Description: To obtain a list of recipients

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::RecipientsApi.new
opts = { 
  object_limit: 100, # Integer | Query parameter to change de default limitation of objects in the result data array
  object_offset: 0, # Integer | Query parameter to change de default offset of objects in the result data array
  filter_job_id: 'filter_job_id_example', # String | Query parameter to fetch after recipient related to specific fax job
  filter_same_account: false, # BOOLEAN | Query parameter to fetch recipient related to jobs linked to the used token/key for authorization
  filter_fax_number: 'filter_fax_number_example', # String | Query parameter to fetch recipients after his fax number
  filter_fax_number_norm: 'filter_fax_number_norm_example', # String | Query parameter to fetch recipients after his normed fax number
  filter_recipient_reference: 'filter_recipient_reference_example', # String | Query parameter to fetch recipients after his recipient reference
  filter_international_dialing_code: 'filter_international_dialing_code_example', # String | Query parameter to fetch recipients after his international dialing code
  filter_result_code: 'filter_result_code_example', # String | Query parameter to fetch recipients after his result code
  filter_result_text: 'filter_result_text_example', # String | Query parameter to fetch recipients after his result text
  sort_field: 'sort_field_example', # String | Available sort options for the result data array.
  sort_order: 'asc' # String | Describes the order for used sort fields
}

begin
  #/recipients
  result = api_instance.get_recipients(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling RecipientsApi->get_recipients: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **object_limit** | **Integer**| Query parameter to change de default limitation of objects in the result data array | [optional] [default to 100]
 **object_offset** | **Integer**| Query parameter to change de default offset of objects in the result data array | [optional] [default to 0]
 **filter_job_id** | **String**| Query parameter to fetch after recipient related to specific fax job | [optional] 
 **filter_same_account** | **BOOLEAN**| Query parameter to fetch recipient related to jobs linked to the used token/key for authorization | [optional] [default to false]
 **filter_fax_number** | **String**| Query parameter to fetch recipients after his fax number | [optional] 
 **filter_fax_number_norm** | **String**| Query parameter to fetch recipients after his normed fax number | [optional] 
 **filter_recipient_reference** | **String**| Query parameter to fetch recipients after his recipient reference | [optional] 
 **filter_international_dialing_code** | **String**| Query parameter to fetch recipients after his international dialing code | [optional] 
 **filter_result_code** | **String**| Query parameter to fetch recipients after his result code | [optional] 
 **filter_result_text** | **String**| Query parameter to fetch recipients after his result text | [optional] 
 **sort_field** | **String**| Available sort options for the result data array. | [optional] 
 **sort_order** | **String**| Describes the order for used sort fields | [optional] [default to asc]

### Return type

[**Recipients**](Recipients.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



